CREATE OR REPLACE FUNCTION SEF2_BLOCOC(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_IND_IPI      IN VARCHAR2,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE) RETURN VARCHAR
AS
   V_CONTREGC        NUMBER;
   V_MOVIMENT        NUMBER;
   V_SEQUPROD        NUMBER;
   V_SEQUENCIAL      VARCHAR2(100);
   V_IDFRETE         VARCHAR2(1);
   V_IDSEGUR         VARCHAR2(1);
   V_IDOUTROS        VARCHAR2(1);
   TIPOOPER_COMPL_S  VARCHAR2(02);
   TIPOOPER_COMPL_E  VARCHAR2(02);
   V_NRSEQUMAPAPU    VARCHAR2(10);
   V_COD_NAT         VARCHAR2(100);
   V_COD_PAR         VARCHAR2(100);
   V_PRODUTO         VARCHAR2(100);
BEGIN
   V_CONTREGC := 0;

   /*busca o tipo de operao de complemento */
   SELECT MAX(TIPOOPER_S), MAX(TIPOOPER_E)
     INTO TIPOOPER_COMPL_S, TIPOOPER_COMPL_E
    FROM
   (
     SELECT DECODE(IDENTRSAIDOP,'S',CDTIPOOPER,NULL) AS TIPOOPER_S,
            DECODE(IDENTRSAIDOP,'E',CDTIPOOPER,NULL) AS TIPOOPER_E
      FROM TIPOOPERAC
     WHERE UPPER(NMTIPOOPER) LIKE '%NF COMPLEMENTO%'
      AND CDTIPOOPER <> '03');

   BEGIN
      SELECT EN.IDENCARGO
      INTO V_IDFRETE
      FROM RELACENCARGO E, ENCARGO EN
      WHERE E.CDENCARGO = EN.CDENCARGO AND
            E.IDENCARGODOS LIKE '%FRET%';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDFRETE    := NULL;
   END;
   BEGIN
      SELECT EN.IDENCARGO
      INTO V_IDSEGUR
      FROM RELACENCARGO E, ENCARGO EN
      WHERE E.CDENCARGO = EN.CDENCARGO AND
            E.IDENCARGODOS LIKE '%SEGU%';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDSEGUR    := NULL;
   END;
   BEGIN
      SELECT EN.IDENCARGO
      INTO V_IDOUTROS
      FROM RELACENCARGO E, ENCARGO EN
      WHERE E.CDENCARGO = EN.CDENCARGO AND
            E.IDENCARGODOS LIKE '%OUTR%';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDOUTROS    := NULL;
   END;

   BEGIN
      SELECT NRSEQUMAPAPU
        INTO V_NRSEQUMAPAPU
        FROM MAPAAPURAC M
       WHERE M.CDEMPRESA = P_CDEMPRESA
         AND M.CDINSCESTA = P_CDINSCESTA
         AND M.CDIMPOSTO = P_CDIMPOSTO
         AND M.DTINIPERIODO = P_DTINICIAL
         AND M.DTFIMPERIODO = P_DTFINAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NRSEQUMAPAPU := NULL;
   END;

   /*REGISTRO C020*/
   FOR C_REGC020 IN (SELECT ('|C020'                             || '|' ||
                            NF.IND_OPER                          || '|' || --operacao
                            NF.IND_EMIT                          || '|' || --emissao
                            REPLACE(DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),' ')  || '|' || --codigo do participante
                            NF.CDMODDOCFISC                                                      || '|' || --modelo de documento
                            DECODE(IDSTATUSNFE,'D','80',DECODE(IDSTATUS,'C','90',DECODE(IDENTRSAIDOP,'S',DECODE(CDTIPOOPER,'03','20',TIPOOPER_COMPL_S,'20','00'),DECODE(CDTIPOOPER,'03','20',TIPOOPER_COMPL_E,'20','00')))) ||'|'|| --situacao do documento
                            REPLACE(CASE WHEN NVL(NF.SERIE,'0') IN ('-','0') THEN DECODE(CDMODDOCFISC,'55','0','1') ELSE NF.SERIE END,'.','-')||'|'|| --serie
                            LTRIM(NF.NRNOTAFISC,'0')                                                   || '|' || --numero do documento
                            DECODE(NF.CDMODDOCFISC,'55',NRACESSONFE,'')                                || '|' || --chave de acesso
                            DECODE(IND_OPER,'0',TO_CHAR(NF.DTEMISSAO,'ddmmyyyy'),'')                   || '|' || --data de emissao
                            TO_CHAR(DECODE(NF.IDENTRSAIDOP,'E',NF.DTENTRSAID,NF.DTEMISSAO),'ddmmyyyy') || '|' || --data de entrada/saida
                            NF.CDFISCOPERNF || '|' || --codigo da natureza
                            DECODE(NF.IDSTATUS, 'C', '', DECODE(PGTO.DTORIGVENREC, NF.DTEMISSAO, '0', '1'))                    || '|' || --pagamento
                            REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',') || '|' || --valor do documento
                            DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'D'),2), '999999999990.00')), '.', ',')) || '|' || --valor desconto
                            DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'A'),2), '999999999990.00')), '.', ',')) || '|' || --valor acrescimo
                            DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRPRODUTOS,2), '999999999990.00')), '.', ',')) || '|' || --valor mercadorias
                            REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, V_IDFRETE)),2), '999999999990.00')), '.', ',') || '|' || --valor frete
                            REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, V_IDSEGUR)),2), '999999999990.00')), '.', ',') || '|' || --valor seguro
                            DECODE(NF.IDSTATUS,'C','','0,00') ||'|'|| --outras despesas acessrias
                            '' || '|' || --operacoes tributadas iss
                            REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', NF.VRBASECALCNF),2), '999999999990.00')), '.', ',') || '|' || --base calculo icms
                            REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', NF.VRIMPOSTONF),2), '999999999990.00')), '.', ',') || '|' || --valor icms
                            REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUS,'C','',DECODE(VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1'),0,'',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1'))), '999999999990.00')), '.', ',') || '|' || --base calculo st
                            REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUS,'C','',DECODE(VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1'),0,'',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1'))), '999999999990.00')), '.', ',') || '|' || --valor icms st
                            '' || '|' || --valor icms antecipacao
                            DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'10','I','1')), '999999999990.00')), '.', ','),'') || '|' || --valor IPI
                            '' || '|'  ) AS DADOS,
                            NF.CDFILIAL AS CDFILIAL, NF.NRLANCTONF AS NRLANCTONF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                            NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU, NF.CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                            NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, NF.VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                            DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))) AS COD_PAR,
                            DECODE(IDSTATUS,'C','02',DECODE(IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END))) AS SITU_DOC,
                            NF.IDSTATUSNFE, DECODE(IDSTATUSNFE,'D','80',DECODE(IDSTATUS,'C','90',DECODE(IDENTRSAIDOP,'S',DECODE(CDTIPOOPER,'03','20',TIPOOPER_COMPL_S,'20','00'),DECODE(CDTIPOOPER,'03','20',TIPOOPER_COMPL_E,'20','00')))) as SIT_DOC,
                            (CASE WHEN (NF.IND_OPER='0') AND (NF.IND_EMIT='1') THEN 'S' ELSE 'N' END) AS OBRG_IE
                       FROM (SELECT DECODE(IDENTRSAIDOP, 'E', '0','1') AS IND_OPER,
                                    DECODE(N.IDENTRSAIDOP, 'E', DECODE(N.IDSTATUSNFE,'A','0',DECODE(N.IDSTATUS,'A','0','1')), '0') AS IND_EMIT, NRACESSONFE,
                                    I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE AS SERIE,
                                    N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                    N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                    TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                    N.NRNOTAFISCALELE, CDTIPOOPER, IDSTATUSNFE
                               FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01', '04','55')
                              GROUP BY DECODE(IDENTRSAIDOP, 'E', '0','1'),
                                    DECODE(N.IDENTRSAIDOP, 'E', DECODE(N.IDSTATUSNFE,'A','0',DECODE(N.IDSTATUS,'A','0','1')), '0'),
                                    I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE,
                                    N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                    N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE,CDTIPOOPER,IDSTATUSNFE
                              UNION ALL
                             SELECT DECODE(IDENTRSAIDOP, 'E', '0','1') AS IND_OPER,
                                    DECODE(N.IDENTRSAIDOP, 'E', DECODE(N.IDSTATUSNFE,'A','0',DECODE(N.IDSTATUS,'A','0','1')), '0') AS IND_EMIT, NRACESSONFE,
                                    I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIEENTR AS SERIE,
                                    N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                    N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                    TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                    N.NRNOTAFISCALELE,CDTIPOOPER, IDSTATUSNFE
                               FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS' )
                                AND N.IDENTRSAIDOP    = 'E'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01', '04','55')
                              GROUP BY DECODE(IDENTRSAIDOP, 'E', '0','1'),
                                    DECODE(N.IDENTRSAIDOP, 'E', DECODE(N.IDSTATUSNFE,'A','0',DECODE(N.IDSTATUS,'A','0','1')), '0'),
                                    I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.NRNOTAFISC, N.CDSERIEENTR, N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, NRACESSONFE,
                                    N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE,
                                    N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE,CDTIPOOPER, IDSTATUSNFE
                              UNION ALL /*Nf's Denegadas*/
                             SELECT '1' AS IND_OPER, '0' AS IND_EMIT, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,
                                    N.CDSERIE AS SERIE, N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS,
                                    N.IDPGTOFRETE, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE,
                                    N.CDFORNECED, N.IDORIGDESTNF, TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF,
                                    N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                    TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                    N.NRNOTAFISCALELE, CDTIPOOPER, IDSTATUSNFE
                               FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP
                              WHERE N.CDEMPRESA     =  P_CDEMPRESA
                                AND N.CDINSCESTA    = P_CDINSCESTA
                                AND N.DTEMISSAO     BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND N.IDENTRSAIDOP  = 'S'
                                AND N.CDMODDOCFISC  IN ('01','04','55')
                                AND N.IDSTATUSNFE   = 'D'
                                AND N.CDFILIAL      = I.CDFILIAL
                                AND N.NRLANCTONF    = I.NRLANCTONF
                                AND I.CDIMPOSTO     = IP.CDIMPOSTO
                                AND IP.CDIMPOSTONFE  = P_CDIMPOSTO
                              GROUP BY NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE,
                                    N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                    N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE,
                                    N.CDFORNECED, N.IDORIGDESTNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    N.NRNOTAFISCALELE, CDTIPOOPER, IDSTATUSNFE
                              UNION ALL /*Nf's Canceladas*/
                             SELECT '1' AS IND_OPER, '0' AS IND_EMIT, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,
                                    N.CDSERIE AS SERIE, N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS,
                                    N.IDPGTOFRETE, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                    N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, '5102' AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE,
                                    N.CDFORNECED, N.IDORIGDESTNF, '0' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                    '0' AS VRBASECALCNF, '0' AS VRIMPOSTONF, '0' AS VROUTRCRED,'0' AS VRISENTRIB, N.NRNOTAFISCALELE, CDTIPOOPER, IDSTATUSNFE
                               FROM NOTAFISCAL N
                              WHERE N.CDEMPRESA    =  P_CDEMPRESA
                                AND N.CDINSCESTA   = P_CDINSCESTA
                                AND N.DTEMISSAO    BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND N.IDENTRSAIDOP = 'S'
                                AND N.CDMODDOCFISC IN ('01','04','55')
                                AND N.IDSTATUS     = 'C')NF,
                            (SELECT MAX(C.DTORIGVENREC) DTORIGVENREC,  N.CDFILIAL, N.NRLANCTONF
                               FROM NOTAFISCAL N, CONTARECEBER C
                              WHERE N.CDFILIAL   = C.CDFILIAL
                                AND N.NRLANCTONF = C.NRLANCTONF
                              GROUP BY N.CDFILIAL, N.NRLANCTONF) PGTO, CFOPPADRAO CF
                      WHERE NF.CDFILIAL     = PGTO.CDFILIAL(+)
                        AND NF.NRLANCTONF   = PGTO.NRLANCTONF(+)
                        AND NF.CDFISCOPERNF = CF.CDCFOPPADRAO(+)
                      ORDER BY SIT_DOC)LOOP

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('301'||LPAD(RTRIM(V_CONTREGC), 7, '0'), C_REGC020.DADOS, P_NRSEQARQMAG);
      V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
      V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

      /* CODIDO DO PARTICIPANTE - LINHA 0150*/
      SELECT MAX(CDCHAVEREG)
        INTO V_COD_PAR
        FROM TMP_REGDADOSSEF2
       WHERE CDCHAVEREG = C_REGC020.COD_PAR
         AND CDREGISTRO = '0150';
      IF (V_COD_PAR IS NULL) AND (C_REGC020.COD_PAR IS NOT NULL) THEN
         V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
         INSERT INTO TMP_REGDADOSSEF2
           (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO2)
         VALUES
           ('0150', V_SEQUPROD, C_REGC020.COD_PAR, C_REGC020.IDORIGDESTNF, C_REGC020.OBRG_IE);
      END IF;
      V_COD_PAR := null;

      /*REGISTRO C300*/
      FOR C_REGC300 IN (SELECT (PR.CDARVPROD                                                                                                                                            || '|' || -- codigo do item
                               PR.SGUNIDADE                                   												                                                                      || '|' || -- unidade
                               REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRUNITITEM,3), '999999999990.000')), '.', ',')                                                                           || '|' || -- valor unitario
                               REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(SUM(IT.QTITEMPROD),0,0.001,SUM(IT.QTITEMPROD)),3), '999999999990.000')), '.', ',')                                   || '|' || -- quantidade
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRDESCITEM),2), '999999999990.00')), '.', ',')                                                                       || '|' || -- valor desconto
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(CASE WHEN IT.VRCONTITEM>=(IT.VRTOTAITEM-IT.VRDESCITEM) THEN IT.VRCONTITEM-(IT.VRTOTAITEM-IT.VRDESCITEM) ELSE 0 END),2), '999999999990.00')), '.', ',') || '|' || -- valor acrescimo
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRTOTAITEM),2), '999999999990.00')), '.', ',')                                                                       || '|' || -- valor liquido
                               LPAD(NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC),8,'0')                                                                                                        || '|' || -- codigo ncm
                               LPAD(NVL(IP.CDSITUTRIBIT,0), 3, '0')                                                                                                                    || '|' || -- cst
                               IP.CDFISCOPERIT                                								                                                           				             || '|' || -- cfop
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IP.CDFISCALIT,'1',IP.VRBASECALCIT,0)),2), '999999999990.00')), '.', ',')                                         || '|' || -- base calculo icms
                               REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT,'1',DECODE(IP.VRALIQITEM,0,'',IP.VRALIQITEM),''),2), '999999999990.00')), '.', ',')                    || '|' || -- aliquota icms
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IP.CDFISCALIT,'1',IP.VRIMPOSTOIT,0)),2), '999999999990.00')), '.', ',')                                          || '|' || -- valor icms
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '80', 'B','1')),2), '999999999990.00')), '.', ',')   || '|' || -- base calculo st
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '80', 'A','1'),0,'',VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '80', 'A','1'))),2), '999999999990.00')), '.', ',')   || '|' || -- aliquota st
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '80', 'I','1')),2), '999999999990.00')), '.', ',')   || '|' || -- valor st
                               DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '10', 'B','1')),2), '999999999990.00')), '.', ','),'') || '|' || -- base calculo ipi
                               DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '10', 'A','1')),2), '999999999990.00')), '.', ','),'') || '|' || -- aliquota ipi
                               DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, '10', 'I','1')),2), '999999999990.00')), '.', ','),'') || '|'  ) AS DADOS, -- valor ipi
                               PR.CDPRODUTO, PR.SGUNIDADE AS UNID, IP.CDFISCOPERIT, IT.DSCDFISOPEIT
                          FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                         WHERE IT.CDFILIAL      = C_REGC020.CDFILIAL
                           AND IT.NRLANCTONF    = C_REGC020.NRLANCTONF
                           AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                           AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                           AND IT.CDFILIAL      = IP.CDFILIAL
                           AND IT.NRLANCTONF    = IP.NRLANCTONF
                           AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                           AND IT.CDPRODUTO     = PR.CDPRODUTO
                           AND IP.NRITPROIMPOS  =  '1'
                           AND DECODE(C_REGC020.SIT_DOC,'20',1,ROUND(IT.QTITEMPROD,3)) > 0
                           AND DECODE(C_REGC020.SIT_DOC,'20',1,ROUND(IT.VRTOTAITEM,3)) > 0
                           AND C_REGC020.SIT_DOC <> '90'
                         GROUP BY PR.CDARVPROD, PR.SGUNIDADE, IT.VRUNITITEM, LPAD(NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC),8,'0'),
                                  LPAD(NVL(IP.CDSITUTRIBIT,0), 3, '0'), IP.CDFISCOPERIT,
                                  DECODE(IP.CDFISCALIT,'1',DECODE(IP.VRALIQITEM,0,'',IP.VRALIQITEM),''),
                                  PR.CDPRODUTO, IT.DSCDFISOPEIT
                         UNION ALL
                        SELECT (SELECT MAX(P.CDARVPROD)
                                  FROM TMP_REGDADOSSEF2 T, PRODUTO P
                                 WHERE T.CDREGISTRO = '0200'
                                   AND T.CDCHAVEREG = P.CDPRODUTO)                      || '|' || -- codigo do item
                               ''                                   							 || '|' || -- unidade
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.000')), '.', ',') || '|' || -- valor unitario
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.000')), '.', ',') || '|' || -- quantidade
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- valor desconto
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- valor acrescimo
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- valor liquido
                               ''                                                       || '|' || -- codigo ncm
                               ''                                                       || '|' || -- cst
                               '5102'                            				             || '|' || -- cfop
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- base calculo icms
                               ''                                                       || '|' || -- aliquota icms
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- valor icms
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- base calculo st
                               ''                                                       || '|' || -- aliquota st
                               REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ',')  || '|' || -- valor st
                               DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ','),'') || '|' || -- base calculo ipi
                               ''                                                       || '|' || -- aliquota ipi
                               DECODE(P_IND_IPI,'0',REPLACE(LTRIM(TO_CHAR(0, '999999999990.00')), '.', ','),'') || '|'  AS DADOS, -- valor ipi
                               '' AS CDPRODUTO, '' AS UNID, '5102' AS CDFISCOPERIT, '' AS DSCDFISOPEIT
                          FROM DUAL
                         WHERE C_REGC020.SIT_DOC = '90') LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('301'||LPAD(RTRIM(V_CONTREGC), 7, '0'), '|C300'|| '|' ||V_SEQUENCIAL|| '|' || C_REGC300.DADOS, P_NRSEQARQMAG);
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
         V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;

         /* CODIGO DO CFOP - LINHA 0400*/
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_NAT
           FROM TMP_REGDADOSSEF2
          WHERE CDCHAVEREG = C_REGC300.CDFISCOPERIT
            AND CDREGISTRO = '0400';
         IF (V_COD_NAT IS NULL) AND (C_REGC300.CDFISCOPERIT IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSEF2
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
            VALUES
              ('0400', V_SEQUPROD, C_REGC300.CDFISCOPERIT, C_REGC300.DSCDFISOPEIT);
         END IF;
         V_COD_NAT := null;

         /* CODIGO DO PRODUTO - LINHA 0200*/
         SELECT MAX(CDCHAVEREG)
           INTO V_PRODUTO
           FROM TMP_REGDADOSSEF2
          WHERE CDCHAVEREG = C_REGC300.CDPRODUTO
            AND CDREGISTRO = '0200';
         IF (V_PRODUTO IS NULL) AND (C_REGC300.CDPRODUTO IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSEF2
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0200', V_SEQUPROD, C_REGC300.CDPRODUTO);
         END IF;
         V_PRODUTO := NULL;
      END LOOP;
   END LOOP;

   /*REGISTRO C550*/
   FOR C_REGC550 IN(SELECT ('|C550'                                                                                                                                     || '|' ||
                            ''                                                                                                                                          || '|' || -- cpf
                            ''                                                                                                                                          || '|' || -- cpnj
                            N.CDMODDOCFISC                                                                                                                              || '|' || -- modelo de documento
                            DECODE(IDSTATUS,'C','10',DECODE(IDENTRSAIDOP,'S',DECODE(CDTIPOOPER,'03','02',TIPOOPER_COMPL_S,'02','01'),DECODE(CDTIPOOPER,'03','02',TIPOOPER_COMPL_E,'02','01'))) ||'|'|| --situacao do documento
                            CASE WHEN N.CDSERIE = 'D1' THEN REPLACE(N.CDSERIE,'D1','D') ELSE N.CDSERIE  END                                                                                                                                  || '|' || -- serie
                            CASE WHEN N.CDSERIE = 'D1' THEN '1' ELSE '' END                                                                                                                                          || '|' || -- sub-serie
                            LTRIM(NRNOTAFISC, '0')                                                                                                                      || '|' || -- numero documento
                            TO_CHAR(N.DTEMISSAO,'ddmmyyyy')                                                                                                             || '|' || -- data emissao
                            'SP10'                                                                                                                              || '|' || -- codigo da operacao
                            REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',')                                                                 || '|' || -- valor documento
                            DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D'),2), '999999999990.00')), '.', ',')) || '|' || --valor desconto
                            DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A'),2), '999999999990.00')), '.', ',')) || '|' || --valor acrescimo
                            DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ','))                                  || '|' || --valor mercadorias
                            REPLACE(LTRIM(TO_CHAR(SUM(ROUND(I.VRBASECALCNF,2)), '999999999990.00')), '.', ',')                                                               || '|' || -- base calculo icms
                            REPLACE(LTRIM(TO_CHAR(SUM(ROUND(I.VRIMPOSTONF,2)), '999999999990.00')), '.', ',')                                                                || '|' || -- valor icms
                            ''     || '|' ) AS DADOS, -- inf. complementar
                            I.NRLANCTONF, I.CDFILIAL
                      FROM IMPOSTONF I, NOTAFISCAL N, IMPOSTO IM
                     WHERE IM.CDIMPOSTONFE = P_CDIMPOSTO
                       AND I.NRSEQUMAPAPU  = V_NRSEQUMAPAPU
                       AND IM.CDIMPOSTO    = I.CDIMPOSTO
                       AND N.CDMODDOCFISC  = '02'
                       AND NVL(I.IDIMPOSTONF, '1') <> '3'
                       AND I.CDFILIAL      = N.CDFILIAL
                       AND I.NRLANCTONF    = N.NRLANCTONF
                       AND N.IDENTRSAIDOP  = 'S'
                       AND N.IDSISTEMA     <> 'FIS'
                     GROUP BY N.CDMODDOCFISC,
                              DECODE(IDSTATUS,'C','10',DECODE(IDENTRSAIDOP,'S',DECODE(CDTIPOOPER,'03','02',TIPOOPER_COMPL_S,'02','01'),DECODE(CDTIPOOPER,'03','02',TIPOOPER_COMPL_E,'02','01'))),
                              N.CDSERIE, LTRIM(NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'), REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ','),
                              DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D'),2), '999999999990.00')), '.', ',')),
                              DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A'),2), '999999999990.00')), '.', ',')),
                              DECODE(N.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ',')), I.NRLANCTONF, I.CDFILIAL) LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('303'||LPAD(RTRIM(V_CONTREGC), 7, '0'), C_REGC550.DADOS, P_NRSEQARQMAG);
      V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
      V_CONTREGC := NVL(V_CONTREGC,0) + 1;

      /*REGISTRO C560*/
      FOR C_REGC560 IN (SELECT (PR.CDARVPROD                                                                                                                                                || '|' || -- codigo do item
                                PR.SGUNIDADE                                   												                    || '|' || -- unidade
                                REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRUNITITEM,6), '999999999990.000000')), '.', ',')                                                                            || '|' || -- valor unitario
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.QTITEMPROD),3), '999999999990.000')), '.', ',')                                                                               || '|' || -- quantidade
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRDESCITEM),2), '999999999990.00')), '.', ',')                                                                                || '|' || -- valor desconto
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(CASE WHEN IT.VRCONTITEM>=(IT.VRTOTAITEM-IT.VRDESCITEM) THEN IT.VRCONTITEM-(IT.VRTOTAITEM-IT.VRDESCITEM) ELSE 0 END),2), '999999999990.00')), '.', ',') || '|' || -- valor acrescimo
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRTOTAITEM),2), '999999999990.00')), '.', ',')                                                                                || '|' || -- valor liquido
                                LPAD(NVL(IP.CDSITUTRIBIT,0), 3, '0')                                                                                                                        || '|' || -- cst
                                IP.CDFISCOPERIT                                												                    || '|' || -- cfop
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0)),2), '999999999990.00')), '.', ',')                                               || '|' || -- base calculo icms
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT,'1',DECODE(IP.VRALIQITEM,0,'',IP.VRALIQITEM),''),2), '999999999990.00')), '.', ',')                                                 || '|' || -- aliquota icms
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT, 0)),2), '999999999990.00')), '.', ',')                                                || '|'  ) AS DADOS, -- valor icms
                                PR.CDPRODUTO
                          FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                         WHERE IT.CDFILIAL      = C_REGC550.CDFILIAL
                           AND IT.NRLANCTONF    = C_REGC550.NRLANCTONF
                           AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                           AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                           AND IT.CDFILIAL      = IP.CDFILIAL
                           AND IT.NRLANCTONF    = IP.NRLANCTONF
                           AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                           AND IT.CDPRODUTO     = PR.CDPRODUTO
                           AND IP.NRITPROIMPOS  =  '1'
                           AND ROUND(IT.QTITEMPROD,3) > 0
                         GROUP BY PR.CDARVPROD, PR.SGUNIDADE, IT.VRUNITITEM, LPAD(NVL(IP.CDSITUTRIBIT,0), 3, '0'),
                                  IP.CDFISCOPERIT, DECODE(IP.CDFISCALIT,'1',DECODE(IP.VRALIQITEM,0,'',IP.VRALIQITEM),''), PR.CDPRODUTO) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('303'||LPAD(RTRIM(V_CONTREGC), 7, '0'), '|C560|'||V_SEQUENCIAL||'|'||C_REGC560.DADOS, P_NRSEQARQMAG);
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* CODIGO DO PRODUTO - 0200 */
         SELECT MAX(CDCHAVEREG)
           INTO V_PRODUTO
           FROM TMP_REGDADOSSEF2
          WHERE CDCHAVEREG = C_REGC560.CDPRODUTO
            AND CDREGISTRO = '0200';
         IF (V_PRODUTO IS NULL) AND (C_REGC560.CDPRODUTO IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSEF2
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0200', V_SEQUPROD, C_REGC560.CDPRODUTO);
         END IF;
      END LOOP;
   END LOOP;

   /*REGISGRO C600*/
   FOR C_REGC600 IN (SELECT '|C600'  ||'|'||
                            CPF      ||'|'||
                            CNPJ     ||'|'||
                            COD_MOD  ||'|'||
                            COD_SIT  ||'|'||
                            ECF_CX   ||'|'||
                            ECF_FAB  ||'|'||
                            CRO      ||'|'||
                            CRZ      ||'|'||
                            NUM_DOC  ||'|'||
                            DT_DOC   ||'|'||
                            COP      ||'|'||
                            VL_DOC   ||'|'||
                            VL_CANC  ||'|'||
                            VL_DESC  ||'|'||
                            VL_ACRE  ||'|'||
                            VL_OP_ISS||'|'||
                            VL_BC    ||'|'||
                            VL_ICMS  ||'|'||
                            VL_ISEN  ||'|'||
                            VL_N_TRIB||'|'||
                            VL_ST    ||'|' AS DADOS,
                            CDFILIAL, CDCAIXA, DTREDUCAOZ
                       FROM (SELECT '' AS CPF,
                                    '' AS CNPJ,
                                    '2D' AS COD_MOD,
                                    '00' AS COD_SIT,
                                    RZ.CDCAIXA AS ECF_CX,
                                    RZ.NRSERIEREDZ AS ECF_FAB,
                                    RZ.NRREINIREDZ AS CRO,
                                    RZ.NRREDREDZ AS CRZ,
                                    SUBSTR(LPAD(RZ.NRULTCFREDZ,10,'0'),2,9) AS NUM_DOC,
                                    TO_CHAR(RZ.DTREDUCAOZ,'ddmmyyyy') AS DT_DOC,
                                    'SP10' AS COP,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRVENLIQREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_DOC,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRTOTCANREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_CANC,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRTOTDESREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_DESC,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRTOTACRREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_ACRE,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRISSREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_OP_ISS,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IZ.VRBCALCIMPRZ,0),2), '9999999999990.00')), '.', ',') AS VL_BC,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IZ.VRIMPOSTORZ,0),2), '9999999999990.00')), '.', ',') AS VL_ICMS,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRISENCREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_ISEN,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRNINCIDREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_N_TRIB,
                                    REPLACE(LTRIM(TO_CHAR(ROUND(NVL(RZ.VRSTRIBREDZ,0),2), '9999999999990.00')), '.', ',') AS VL_ST,
                                    RZ.CDFILIAL, RZ.CDCAIXA, RZ.DTREDUCAOZ
                               FROM FILIAL FI, REDUCAOZ RZ, (SELECT SUM(IP.VRBCALCIMPRZ) AS VRBCALCIMPRZ, SUM(IP.VRIMPOSTORZ) AS VRIMPOSTORZ,
                                                                    IP.CDFILIAL, IP.CDCAIXA, IP.NRECFREDZ, IP.DTREDUCAOZ
                                                               FROM IMPOSTOREDZ IP, IMPOSTO IM
                                                              WHERE IP.CDIMPOSTO    = IM.CDIMPOSTO
                                                                AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                              GROUP BY IP.CDFILIAL, IP.CDCAIXA, IP.NRECFREDZ, IP.DTREDUCAOZ) IZ
                              WHERE FI.CDEMPRESA    = P_CDEMPRESA
                                AND FI.CDINSCESTA   = P_CDINSCESTA
                                AND RZ.CDFILIAL     = FI.CDFILIAL
                                AND RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND RZ.CDFILIAL     = IZ.CDFILIAL(+)
                                AND RZ.CDCAIXA      = IZ.CDCAIXA(+)
                                AND RZ.NRECFREDZ    = IZ.NRECFREDZ(+)
                                AND RZ.DTREDUCAOZ   = IZ.DTREDUCAOZ(+)
                                AND RZ.IDSTATUS     = 'A'
                                AND RZ.VRVENBRUREDZ <> RZ.VRTOTCANREDZ
                              ORDER BY RZ.CDCAIXA, RZ.NRULTCFREDZ)) LOOP

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('305'||LPAD(RTRIM(V_CONTREGC), 7, '0'), C_REGC600.DADOS, P_NRSEQARQMAG);
      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
      V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

      /*REGISTRO C610*/
      FOR C_REGC610 IN (SELECT --'|C610'   ||'|'||
                               --NUM_ITEM  ||'|'||
                               COD_ITEM  ||'|'||
                               UNID      ||'|'||
                               VL_UNIT   ||'|'||
                               QTD       ||'|'||
                               VL_DESC   ||'|'||
                               VL_ACMO   ||'|'||
                               VL_ITEM   ||'|'||
                               CST       ||'|'||
                               CFOP      ||'|'||
                               VL_BC_ICMS||'|'||
                               ALIQ_ICMS ||'|'||
                               VL_ICMS   ||'|'||
                               VL_ISN    ||'|'||
                               VL_NT     ||'|'||
                               VL_ST     ||'|' AS DADOS, CDPRODUTO
                          FROM (SELECT --IV.NRSEQUITVEND AS NUM_ITEM,
                                       PR.CDARVPROD AS COD_ITEM,
                                       PR.SGUNIDADE AS UNID,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0),6), '9999999999990.000000')), '.', ',') AS VL_UNIT,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IV.QTPRODVEND),6), '9999999999990.000000')), '.', ',') AS QTD,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IV.VRDESITVEND),2), '9999999999990.00')), '.', ',') AS VL_DESC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IV.VRACRITVEND),2), '9999999999990.00')), '.', ',') AS VL_ACMO,
                                       REPLACE(LTRIM(TO_CHAR(SUM((TRUNC(QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND)), '9999999999990.00')), '.', ',') AS VL_ITEM,
                                       DECODE(IM.IDTPIMPOSFIS,'T','000','I','040','N','041','060') AS CST,
                                       DECODE(IM.IDTPIMPOSFIS,'F','5405','5102') AS CFOP,
                                       REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS,'T',(TRUNC(QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND),0)), '9999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(IP.VRPEALPRODIT,2), '9999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IP.VRIMPOPRODIT),2), '9999999999990.00')), '.', ',') AS VL_ICMS,
                                       REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS,'I',(TRUNC(QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND),0)), '9999999999990.00')), '.', ',') AS VL_ISN,
                                       REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS,'N',(TRUNC(QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND),0)), '9999999999990.00')), '.', ',') AS VL_NT,
                                       REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS,'F',(TRUNC(QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND),0)), '9999999999990.00')), '.', ',') AS VL_ST,
                                       PR.CDPRODUTO
                                  FROM VENDA VE, ITEMVENDA IV, ITVENDAIMPOS IP, IMPOSTO IM, PRODUTO PR
                                 WHERE VE.CDFILIAL     = C_REGC600.CDFILIAL
                                   AND VE.CDCAIXA      = C_REGC600.CDCAIXA
                                   AND VE.DTENTRVENDA  = C_REGC600.DTREDUCAOZ
                                   AND VE.IDSITUVENDA  = 'O'
                                   AND VE.CDFILIAL     = IV.CDFILIAL
                                   AND VE.CDCAIXA      = IV.CDCAIXA
                                   AND VE.NRSEQVENDA   = IV.NRSEQVENDA
                                   AND IV.CDFILIAL     = IP.CDFILIAL
                                   AND IV.CDCAIXA      = IP.CDCAIXA
                                   AND IV.NRSEQVENDA   = IP.NRSEQVENDA
                                   AND IV.NRSEQUITVEND = IP.NRSEQUITVEND
                                   AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE IN ('00','80')
                                   AND IV.CDPRODUTO    = PR.CDPRODUTO
                                 GROUP BY  PR.CDARVPROD, PR.SGUNIDADE, IV.VRUNITVEND, IV.VRUNITVENDCL, IP.VRPEALPRODIT, PR.CDPRODUTO, IM.IDTPIMPOSFIS)) LOOP

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('305'||LPAD(RTRIM(V_CONTREGC), 7, '0'), '|C610|'||V_SEQUENCIAL||'|'||C_REGC610.DADOS, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');

         /* CODIGO DO PRODUTO - 0200 */
         SELECT MAX(CDCHAVEREG)
           INTO V_PRODUTO
           FROM TMP_REGDADOSSEF2
          WHERE CDCHAVEREG = C_REGC610.CDPRODUTO
            AND CDREGISTRO = '0200';
         IF (V_PRODUTO IS NULL) AND (C_REGC610.CDPRODUTO IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSEF2
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0200', V_SEQUPROD, C_REGC610.CDPRODUTO);
         END IF;
         V_PRODUTO := NULL;

      END LOOP;
   END LOOP;

   IF V_CONTREGC <> 0 THEN
      V_MOVIMENT := 0;
   ELSE
      V_MOVIMENT := 1;
   END IF;

   /* ABERTURA DO BLOCO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('300'||LPAD('0', 7, '0'), '|C001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('399'||LPAD(RTRIM(V_CONTREGC), 7, '0'), '|C990'|| '|' ||V_CONTREGC|| '|', P_NRSEQARQMAG);

   RETURN(LPAD(RTRIM(V_CONTREGC),10,'0')||LPAD(RTRIM(V_SEQUPROD),10,'0'));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SEF2_BLOCOC','5.87.000'); END;
/
